package org.emoflon.ibex.tgg.ui.debug.views.visualisable;

import java.util.Collection;

//import org.eclipse.emf.ecore.EObject;
//import org.emoflon.ibex.tgg.operational.matches.IMatch;
import org.emoflon.ibex.tgg.ui.debug.api.IMatchAdapter;
import org.emoflon.ibex.tgg.ui.debug.api.IRuleAdapter;
import org.emoflon.ibex.tgg.ui.debug.api.IVictoryDataProvider;
import org.emoflon.ibex.tgg.ui.debug.options.IUserOptions;
import org.emoflon.ibex.tgg.ui.debug.plantuml.VictoryPlantUMLGenerator;

//import language.TGGRule;

public class IMatchVisualisation extends VisualisableElement {

    private IMatchAdapter match;
    private IVictoryDataProvider dataProvider;
    private IUserOptions userOptions;

    public IMatchVisualisation(IMatchAdapter pMatch, IVictoryDataProvider pDataProvider, IUserOptions pUserOptions) {
	match = pMatch;
	dataProvider = pDataProvider;
	userOptions = pUserOptions;
    }

    @Override
    protected String generateVisualisationString() {
    IRuleAdapter rule = dataProvider.getRule(match.getRuleName());
	if (rule == null)
	    throw new IllegalArgumentException("Unknown rule");

	Collection<Object> matchNeighborhood = dataProvider.getMatchNeighbourhood(match, 1);

	return VictoryPlantUMLGenerator.visualiseMatch(match, rule, matchNeighborhood, userOptions);
    }

}
